// UwiIsaSetDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "uwidebug.h"
#include "UwiIsaSetDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int CUwiIsaSetDlg::m_csIdcChetbl[] = {
	IDC_CHECK1 ,IDC_CHECK2 ,IDC_CHECK3 ,IDC_CHECK4 ,IDC_CHECK5 ,IDC_CHECK6 ,IDC_CHECK7 ,IDC_CHECK8 ,
	IDC_CHECK9 ,IDC_CHECK10,IDC_CHECK11,IDC_CHECK12,IDC_CHECK13,IDC_CHECK14,IDC_CHECK15,IDC_CHECK16,
	IDC_STATIC };
int CUwiIsaSetDlg::m_csIdcComtbl[] = {
	IDC_COMBO1 ,IDC_COMBO2 ,IDC_COMBO3 ,IDC_COMBO4 ,IDC_COMBO5 ,IDC_COMBO6 ,IDC_COMBO7 ,IDC_COMBO8 ,
	IDC_COMBO9 ,IDC_COMBO10,IDC_COMBO11,IDC_COMBO12,IDC_COMBO13,IDC_COMBO14,IDC_COMBO15,IDC_COMBO16,
	IDC_STATIC };
int CUwiIsaSetDlg::m_csIdcEditbl[] = {
	IDC_EDIT1 ,IDC_EDIT2 ,IDC_EDIT3 ,IDC_EDIT4 ,IDC_EDIT5 ,IDC_EDIT6 ,IDC_EDIT7 ,IDC_EDIT8 ,
	IDC_EDIT9 ,IDC_EDIT10,IDC_EDIT11,IDC_EDIT12,IDC_EDIT13,IDC_EDIT14,IDC_EDIT15,IDC_EDIT16,
	IDC_STATIC };

/////////////////////////////////////////////////////////////////////////////
// CUwiIsaSetDlg _CAO


CUwiIsaSetDlg::CUwiIsaSetDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUwiIsaSetDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUwiIsaSetDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}


void CUwiIsaSetDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUwiIsaSetDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUwiIsaSetDlg, CDialog)
	//{{AFX_MSG_MAP(CUwiIsaSetDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUwiIsaSetDlg bZ[W nh

void CUwiIsaSetDlg::InitCombo()
{
	CComboBox* pcsComb;
	int i;
	for(i=0;m_csIdcComtbl[i]!=IDC_STATIC;i++) {
		pcsComb = (CComboBox*)GetDlgItem(m_csIdcComtbl[i]);
		pcsComb->SetCurSel(m_sIsaRegSet[i].dwType);
	}
}

BOOL CUwiIsaSetDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	ReadIsaReg();
	InitCheck();
	InitEdit();
	InitCombo();
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CUwiIsaSetDlg::InitCheck()
{
	int i;
	CString stWork;
	for(i=0;m_csIdcChetbl[i]!=IDC_STATIC;i++) {
		stWork.Format("No.%02d",i);
		SetDlgItemText(m_csIdcChetbl[i],stWork);
		if(!m_sIsaRegSet[i].dwEnable) continue;
		CheckDlgButton(m_csIdcChetbl[i],BST_CHECKED);
	}
}

void CUwiIsaSetDlg::InitEdit()
{
	int i;
	CString stWork;
	for(i=0;m_csIdcEditbl[i]!=IDC_STATIC;i++) {
		stWork.Format("%04x",m_sIsaRegSet[i].dwBaseAddress);
		SetDlgItemText(m_csIdcEditbl[i],stWork);
	}
}

void CUwiIsaSetDlg::ReadIsaReg()
{
	memset(m_sIsaRegSet,0x00,sizeof(m_sIsaRegSet));
	int i;
	for(i=0;i<16;i++) {
		::uw_Isaboardregread(i,&m_sIsaRegSet[i]);
	}
}

void CUwiIsaSetDlg::WriteIsaReg()
{
	int i;
	for(i=0;i<16;i++) {
		::uw_Isaboardregwrite(i,&m_sIsaRegSet[i]);
	}
}

void CUwiIsaSetDlg::EndCheck()
{
	int i;
	for(i=0;m_csIdcChetbl[i]!=IDC_STATIC;i++) {
		if(IsDlgButtonChecked(m_csIdcChetbl[i])!=BST_CHECKED) continue;
		m_sIsaRegSet[i].dwEnable = DUW_BOARD_ENABLE;
	}
}

void CUwiIsaSetDlg::EndEdit()
{
	char *stopstring;
	int i;
	CString stWork;
	for(i=0;m_csIdcEditbl[i]!=IDC_STATIC;i++) {
		GetDlgItemText(m_csIdcEditbl[i],stWork);
		m_sIsaRegSet[i].dwBaseAddress = strtol(stWork,&stopstring,16);	
	}
}

void CUwiIsaSetDlg::EndCombo()
{
	CComboBox* pcsComb;
	int i;
	for(i=0;m_csIdcComtbl[i]!=IDC_STATIC;i++) {
		pcsComb = (CComboBox*)GetDlgItem(m_csIdcComtbl[i]);
		m_sIsaRegSet[i].dwType = pcsComb->GetCurSel();
	}
}

void CUwiIsaSetDlg::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	EndCheck();
	EndEdit();
	EndCombo();
	WriteIsaReg();
	MessageBox("New configuration is available on restart.", NULL, MB_ICONEXCLAMATION);
	CDialog::OnOK();
}
